#include <stdlib.h>
#include <stdio.h>

#include "lista_estatica.h"

#define TAM	100

LISTA_ESTATICA *criar_lista_estatica() {
  LISTA_ESTATICA *lista = (LISTA_ESTATICA *) malloc(sizeof (LISTA_ESTATICA));

  if (lista != NULL) {

    if (lista->vetor != NULL) {
      lista->fim = -1;
    } else {
      free(lista);
      lista = NULL;
    }
  }

  return lista;
}

void apagar_lista_estatica(LISTA_ESTATICA **lista) {
  if (lista != NULL && *lista != NULL) {
    for (int i = 0; i <= (*lista)->fim; i++) {
      apagar_item(&((*lista)->vetor[i]));
    }

    free(*lista);
    *lista = NULL;
  }
}

int inserir_lista_estatica(LISTA_ESTATICA *lista, ITEM *item) {
  if (lista != NULL && item != NULL) {
    if (!cheia_lista_estatica(lista)) {
      ++lista->fim;
      lista->vetor[lista->fim] = item;
      return 1;
    }
  }
  return 0;
}

ITEM *buscar_lista_estatica(LISTA_ESTATICA *lista, int chave) {
  if (lista != NULL && !vazia_lista_estatica(lista)) {
    for (int i = 0; i <= lista->fim; i++) {
      if (lista->vetor[i]->chave == chave) {
        return lista->vetor[i];
      }
    }
  }
  return NULL;
}

int remover_lista_estatica(LISTA_ESTATICA *lista, int chave) {
  if (lista != NULL) {
    //procurar/remover
    for (int i = 0; i <= lista->fim; i++) {
      if (lista->vetor[i]->chave == chave) {
        apagar_item(&(lista->vetor[i]));
	// coloca ultimo elemento na posicao removida
        lista->vetor[i] = lista->vetor[lista->fim];
        lista->vetor[lista->fim] = NULL;
        lista->fim--;
        return 1;
      }
    }
  }
  return 0;
}

int cheia_lista_estatica(LISTA_ESTATICA *lista) {
  return lista->fim == TAM - 1;
}

int vazia_lista_estatica(LISTA_ESTATICA *lista) {
  return lista->fim == -1;
}

void imprimir_lista_estatica(LISTA_ESTATICA *lista) {
  if (lista != NULL && !vazia_lista_estatica(lista)) {
    for (int i = 0; i <= lista->fim; i++) {
      imprimir_item(lista->vetor[i]);
    }
  }
  printf("\n");
}

int tamanho_lista_estatica(LISTA_ESTATICA *lista) {
  return (lista != NULL) ? lista->fim + 1 : 0;
}
